import { ShareOptions, ShareSingleOptions } from '../types';
export declare function normalizeShareOpenOptions({ ...options }: ShareOptions): {
    message?: string | undefined;
    title?: string | undefined;
    url?: string | undefined;
    urls?: string[] | undefined;
    type?: string | undefined;
    subject?: string | undefined;
    email?: string | undefined;
    recipient?: string | undefined;
    excludedActivityTypes?: string[] | import("../types").ActivityType[] | undefined;
    failOnCancel?: boolean | undefined;
    showAppsToView?: boolean | undefined;
    filename?: string | undefined;
    filenames?: string[] | undefined;
    saveToFiles?: boolean | undefined;
    activityItemSources?: import("../types").ActivityItemSource[] | undefined;
    isNewTask?: boolean | undefined;
};
export declare function normalizeSingleShareOptions({ ...options }: ShareSingleOptions): {
    appId?: string | undefined;
    urls?: string[] | undefined;
    url?: string | undefined;
    type?: string | undefined;
    filename?: string | undefined;
    message?: string | undefined;
    title?: string | undefined;
    subject?: string | undefined;
    email?: string | undefined;
    recipient?: string | undefined;
    social: import("../types").Social.Facebook | import("../types").Social.Pagesmanager | import("../types").Social.Twitter | import("../types").Social.Whatsapp | import("../types").Social.Whatsappbusiness | import("../types").Social.Instagram | import("../types").Social.Googleplus | import("../types").Social.Email | import("../types").Social.Pinterest | import("../types").Social.Linkedin | import("../types").Social.Sms | import("../types").Social.Telegram | import("../types").Social.Snapchat | import("../types").Social.Messenger | import("../types").Social.Viber | import("../types").Social.Discord;
    forceDialog?: boolean | undefined;
} | {
    social: import("../types").Social.InstagramStories;
    appId: string;
    backgroundImage?: string | undefined;
    stickerImage?: string | undefined;
    backgroundBottomColor?: string | undefined;
    backgroundTopColor?: string | undefined;
    attributionURL?: string | undefined;
    backgroundVideo?: string | undefined;
    linkUrl?: string | undefined;
    linkText?: string | undefined;
    title?: string | undefined;
    type?: string | undefined;
    email?: string | undefined;
    url?: string | undefined;
    message?: string | undefined;
    urls?: string[] | undefined;
    filename?: string | undefined;
    subject?: string | undefined;
    recipient?: string | undefined;
    forceDialog?: boolean | undefined;
} | {
    social: import("../types").Social.FacebookStories;
    appId: string;
    backgroundImage?: string | undefined;
    stickerImage?: string | undefined;
    backgroundBottomColor?: string | undefined;
    backgroundTopColor?: string | undefined;
    attributionURL?: string | undefined;
    backgroundVideo?: string | undefined;
    linkUrl?: string | undefined;
    linkText?: string | undefined;
    title?: string | undefined;
    type?: string | undefined;
    email?: string | undefined;
    url?: string | undefined;
    message?: string | undefined;
    urls?: string[] | undefined;
    filename?: string | undefined;
    subject?: string | undefined;
    recipient?: string | undefined;
    forceDialog?: boolean | undefined;
};
//# sourceMappingURL=options.d.ts.map